#![feature(int_from_ascii)]
#![feature(portable_simd)]

use aes::{
    Aes128,
    cipher::{BlockEncrypt, KeyInit, generic_array::GenericArray},
};
use clap::Parser;
use rayon::iter::{IntoParallelIterator, ParallelIterator};
use std::{
    io::{BufRead, Read},
    path::{Path, PathBuf},
    simd::{Simd, num::SimdUint},
};

static RSBOX: [u8; 256] = [
    0x52, 0x09, 0x6a, 0xd5, 0x30, 0x36, 0xa5, 0x38, 0xbf, 0x40, 0xa3, 0x9e, 0x81, 0xf3, 0xd7, 0xfb,
    0x7c, 0xe3, 0x39, 0x82, 0x9b, 0x2f, 0xff, 0x87, 0x34, 0x8e, 0x43, 0x44, 0xc4, 0xde, 0xe9, 0xcb,
    0x54, 0x7b, 0x94, 0x32, 0xa6, 0xc2, 0x23, 0x3d, 0xee, 0x4c, 0x95, 0x0b, 0x42, 0xfa, 0xc3, 0x4e,
    0x08, 0x2e, 0xa1, 0x66, 0x28, 0xd9, 0x24, 0xb2, 0x76, 0x5b, 0xa2, 0x49, 0x6d, 0x8b, 0xd1, 0x25,
    0x72, 0xf8, 0xf6, 0x64, 0x86, 0x68, 0x98, 0x16, 0xd4, 0xa4, 0x5c, 0xcc, 0x5d, 0x65, 0xb6, 0x92,
    0x6c, 0x70, 0x48, 0x50, 0xfd, 0xed, 0xb9, 0xda, 0x5e, 0x15, 0x46, 0x57, 0xa7, 0x8d, 0x9d, 0x84,
    0x90, 0xd8, 0xab, 0x00, 0x8c, 0xbc, 0xd3, 0x0a, 0xf7, 0xe4, 0x58, 0x05, 0xb8, 0xb3, 0x45, 0x06,
    0xd0, 0x2c, 0x1e, 0x8f, 0xca, 0x3f, 0x0f, 0x02, 0xc1, 0xaf, 0xbd, 0x03, 0x01, 0x13, 0x8a, 0x6b,
    0x3a, 0x91, 0x11, 0x41, 0x4f, 0x67, 0xdc, 0xea, 0x97, 0xf2, 0xcf, 0xce, 0xf0, 0xb4, 0xe6, 0x73,
    0x96, 0xac, 0x74, 0x22, 0xe7, 0xad, 0x35, 0x85, 0xe2, 0xf9, 0x37, 0xe8, 0x1c, 0x75, 0xdf, 0x6e,
    0x47, 0xf1, 0x1a, 0x71, 0x1d, 0x29, 0xc5, 0x89, 0x6f, 0xb7, 0x62, 0x0e, 0xaa, 0x18, 0xbe, 0x1b,
    0xfc, 0x56, 0x3e, 0x4b, 0xc6, 0xd2, 0x79, 0x20, 0x9a, 0xdb, 0xc0, 0xfe, 0x78, 0xcd, 0x5a, 0xf4,
    0x1f, 0xdd, 0xa8, 0x33, 0x88, 0x07, 0xc7, 0x31, 0xb1, 0x12, 0x10, 0x59, 0x27, 0x80, 0xec, 0x5f,
    0x60, 0x51, 0x7f, 0xa9, 0x19, 0xb5, 0x4a, 0x0d, 0x2d, 0xe5, 0x7a, 0x9f, 0x93, 0xc9, 0x9c, 0xef,
    0xa0, 0xe0, 0x3b, 0x4d, 0xae, 0x2a, 0xf5, 0xb0, 0xc8, 0xeb, 0xbb, 0x3c, 0x83, 0x53, 0x99, 0x61,
    0x17, 0x2b, 0x04, 0x7e, 0xba, 0x77, 0xd6, 0x26, 0xe1, 0x69, 0x14, 0x63, 0x55, 0x21, 0x0c, 0x7d,
];

static SBOX: [u8; 256] = [
    0x63, 0x7c, 0x77, 0x7b, 0xf2, 0x6b, 0x6f, 0xc5, 0x30, 0x01, 0x67, 0x2b, 0xfe, 0xd7, 0xab, 0x76,
    0xca, 0x82, 0xc9, 0x7d, 0xfa, 0x59, 0x47, 0xf0, 0xad, 0xd4, 0xa2, 0xaf, 0x9c, 0xa4, 0x72, 0xc0,
    0xb7, 0xfd, 0x93, 0x26, 0x36, 0x3f, 0xf7, 0xcc, 0x34, 0xa5, 0xe5, 0xf1, 0x71, 0xd8, 0x31, 0x15,
    0x04, 0xc7, 0x23, 0xc3, 0x18, 0x96, 0x05, 0x9a, 0x07, 0x12, 0x80, 0xe2, 0xeb, 0x27, 0xb2, 0x75,
    0x09, 0x83, 0x2c, 0x1a, 0x1b, 0x6e, 0x5a, 0xa0, 0x52, 0x3b, 0xd6, 0xb3, 0x29, 0xe3, 0x2f, 0x84,
    0x53, 0xd1, 0x00, 0xed, 0x20, 0xfc, 0xb1, 0x5b, 0x6a, 0xcb, 0xbe, 0x39, 0x4a, 0x4c, 0x58, 0xcf,
    0xd0, 0xef, 0xaa, 0xfb, 0x43, 0x4d, 0x33, 0x85, 0x45, 0xf9, 0x02, 0x7f, 0x50, 0x3c, 0x9f, 0xa8,
    0x51, 0xa3, 0x40, 0x8f, 0x92, 0x9d, 0x38, 0xf5, 0xbc, 0xb6, 0xda, 0x21, 0x10, 0xff, 0xf3, 0xd2,
    0xcd, 0x0c, 0x13, 0xec, 0x5f, 0x97, 0x44, 0x17, 0xc4, 0xa7, 0x7e, 0x3d, 0x64, 0x5d, 0x19, 0x73,
    0x60, 0x81, 0x4f, 0xdc, 0x22, 0x2a, 0x90, 0x88, 0x46, 0xee, 0xb8, 0x14, 0xde, 0x5e, 0x0b, 0xdb,
    0xe0, 0x32, 0x3a, 0x0a, 0x49, 0x06, 0x24, 0x5c, 0xc2, 0xd3, 0xac, 0x62, 0x91, 0x95, 0xe4, 0x79,
    0xe7, 0xc8, 0x37, 0x6d, 0x8d, 0xd5, 0x4e, 0xa9, 0x6c, 0x56, 0xf4, 0xea, 0x65, 0x7a, 0xae, 0x08,
    0xba, 0x78, 0x25, 0x2e, 0x1c, 0xa6, 0xb4, 0xc6, 0xe8, 0xdd, 0x74, 0x1f, 0x4b, 0xbd, 0x8b, 0x8a,
    0x70, 0x3e, 0xb5, 0x66, 0x48, 0x03, 0xf6, 0x0e, 0x61, 0x35, 0x57, 0xb9, 0x86, 0xc1, 0x1d, 0x9e,
    0xe1, 0xf8, 0x98, 0x11, 0x69, 0xd9, 0x8e, 0x94, 0x9b, 0x1e, 0x87, 0xe9, 0xce, 0x55, 0x28, 0xdf,
    0x8c, 0xa1, 0x89, 0x0d, 0xbf, 0xe6, 0x42, 0x68, 0x41, 0x99, 0x2d, 0x0f, 0xb0, 0x54, 0xbb, 0x16,
];

fn calculate_models(ciphertexts: &[[u8; 16]]) -> Vec<[Vec<u8>; 16]> {
    let mut r: Vec<[Vec<u8>; 16]> = (0..256)
        .map(|_| {
            [
                vec![0; ciphertexts.len()],
                vec![0; ciphertexts.len()],
                vec![0; ciphertexts.len()],
                vec![0; ciphertexts.len()],
                vec![0; ciphertexts.len()],
                vec![0; ciphertexts.len()],
                vec![0; ciphertexts.len()],
                vec![0; ciphertexts.len()],
                vec![0; ciphertexts.len()],
                vec![0; ciphertexts.len()],
                vec![0; ciphertexts.len()],
                vec![0; ciphertexts.len()],
                vec![0; ciphertexts.len()],
                vec![0; ciphertexts.len()],
                vec![0; ciphertexts.len()],
                vec![0; ciphertexts.len()],
            ]
        })
        .collect();

    for k in 0..16 {
        for j in 0..256 {
            for (i, c) in ciphertexts.iter().enumerate() {
                r[j][k][i] = RSBOX[(c[k] ^ (j as u8)) as usize];
            }
        }
    }

    r
}

fn read_msgs(path: impl AsRef<Path>) -> (Vec<[u8; 16]>, [u8; 16]) {
    let file = std::fs::File::open(path).unwrap();

    let mut bufreader = std::io::BufReader::new(file);

    let mut line = [0; 66];

    let mut r = Vec::new();

    let mut key = [0; 16];
    while bufreader.read_exact(&mut line).is_ok() {
        key = [0; 16];
        let mut msgs = [0; 16];

        for i in 0..16 {
            key[i] = u8::from_ascii_radix(&line[2 * i..2 * i + 2], 16).unwrap();
            msgs[i] = u8::from_ascii_radix(&line[33 + 2 * i..33 + 2 * i + 2], 16).unwrap();
        }

        let key = GenericArray::from(key);
        let mut block = GenericArray::from(msgs);
        let cypher = Aes128::new(&key);

        cypher.encrypt_block(&mut block);

        r.push(*block.as_ref());
    }

    (r, last_round_key(key))
}

const TRACES: usize = 87;

fn read_traces(path: impl AsRef<Path>, capacity: usize) -> Vec<Vec<u8>> {
    let file = std::fs::File::open(path).unwrap();

    let bufreader = std::io::BufReader::new(file);

    let mut r: Vec<Vec<u8>> = (0..TRACES).map(|_| vec![0; capacity]).collect();

    for (i, l) in bufreader.lines().enumerate() {
        let l = l.unwrap();

        for (j, t) in l
            .trim()
            .split(',')
            .map(|t| t.parse::<u8>().unwrap())
            .enumerate()
        {
            r[j][i] = t;
        }
    }

    r
}

const LANES: usize = 32;

fn correlation(
    bit: usize,
    key_hypothesis: usize,
    trace_index: usize,
    cyphtertext: &[[Vec<u8>; 16]],
    traces: &[Vec<u8>],
) -> f64 {
    assert!(
        traces[0].len() < (1 << 16) * LANES,
        "Integers might overflow"
    );

    let mut x = Simd::<u32, LANES>::default();
    let mut y = Simd::<u32, LANES>::default();
    let mut xy = Simd::<u32, LANES>::default();
    let mut ysqr = Simd::<u32, LANES>::default();

    let mask = Simd::<u8, LANES>::splat(1 << (bit % 8));

    for i in 0..traces[0].len() / LANES {
        let xi = Simd::<u8, LANES>::from_slice(&cyphtertext[key_hypothesis][bit / 8][i * LANES..]);
        let xi = (xi & mask).cast();
        let yi = Simd::<u8, LANES>::from_slice(&traces[trace_index][i * LANES..]).cast();

        x += xi;
        y += yi;
        xy += xi * yi;
        ysqr += yi * yi;
    }

    let mut x = x.cast::<u64>().reduce_sum() as i64;
    let mut y = y.cast::<u64>().reduce_sum() as i64;
    let mut xy = xy.cast::<u64>().reduce_sum() as i64;
    let mut ysqr = ysqr.cast::<u64>().reduce_sum() as i64;

    for i in (traces[0].len() / LANES) * LANES..traces[0].len() {
        let xi = (cyphtertext[key_hypothesis][bit / 8][i] & (1 << (bit % 8))) as i64;
        let yi = traces[trace_index][i] as i64;

        x += xi;
        y += yi;
        xy += xi * yi;
        ysqr += yi * yi;
    }

    let xsqr = x * (1 << (bit % 8));

    let n = traces[0].len() as i64;
    let num = (n * xy - x * y) as f64;
    let denom = f64::sqrt((n * xsqr - x * x) as f64) * f64::sqrt((n * ysqr - y * y) as f64);

    num / denom
}

fn last_round_key(mut key: [u8; 16]) -> [u8; 16] {
    for i in 0..10 {
        key = key_schedule(key, i);
    }

    key
}

fn key_schedule(mut key: [u8; 16], round: usize) -> [u8; 16] {
    let rcon = [0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x1B, 0x36];

    let r = [key[13], key[14], key[15], key[12]];

    let mut r = [
        SBOX[r[0] as usize],
        SBOX[r[1] as usize],
        SBOX[r[2] as usize],
        SBOX[r[3] as usize],
    ];

    r[0] ^= rcon[round];

    key[0] ^= r[0];
    key[1] ^= r[1];
    key[2] ^= r[2];
    key[3] ^= r[3];

    for i in 4..16 {
        key[i] ^= key[i - 4];
    }

    key
}

#[derive(Debug, Parser)]
struct Args {
    #[arg(default_value = "./alan/Task-3-example_traces/test_msgs.csv")]
    msgs: PathBuf,
    #[arg(default_value = "./alan/Task-3-example_traces/test_traces.csv")]
    traces: PathBuf,
}

fn main() {
    let start_total = std::time::Instant::now();
    let args = Args::parse();

    let start = std::time::Instant::now();
    let (cyphertext, lrk) = read_msgs(args.msgs);
    println!("read msgs: {:?}", start.elapsed());

    let start = std::time::Instant::now();
    let models = calculate_models(&cyphertext);
    println!("calculate models: {:?}", start.elapsed());

    let start = std::time::Instant::now();
    let traces = read_traces(args.traces, cyphertext.len());
    println!("read traces: {:?}", start.elapsed());

    let start = std::time::Instant::now();
    for bit in 0..128 {
        let (max_index, max) = (0..256)
            .into_par_iter()
            .map(|key_hypothesis| {
                let m = (0..TRACES)
                    .map(|trace_index| {
                        correlation(bit, key_hypothesis, trace_index, &models, &traces).abs()
                    })
                    .reduce(f64::max)
                    .unwrap_or(0.0);
                (key_hypothesis, m)
            })
            .reduce(
                || (0, 0.0),
                |a, b| {
                    if a.1 > b.1 { a } else { b }
                },
            );

        println!(
            "bit: {bit:3}, key_hypothesis: {max_index:3}, max: {max:.5}, correct guess: {}",
            lrk[bit / 8] == max_index as u8
        );
    }
    println!("calculate correlations: {:?}", start.elapsed());
    println!("total: {:?}", start_total.elapsed());
}
